# generated by datamodel-codegen:
#   filename:  data_room_compute_action.json

from __future__ import annotations

from enum import Enum
from typing import Any, Mapping, Optional, Sequence, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class Kind(Enum):
    media = 'media'


class DataRoomComputeAction1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getMatchingValidationReport: Mapping[str, Any]


class DataRoomComputeAction2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getSegmentsValidationReport: Mapping[str, Any]


class DataRoomComputeAction3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getDemographicsValidationReport: Mapping[str, Any]


class DataRoomComputeAction4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getAudiencesValidationReport: Mapping[str, Any]


class DataRoomComputeAction5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    computeInsights: Mapping[str, Any]


class DataRoomComputeAction6(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    computeOverlapStatistics: Mapping[str, Any]


class DataRoomComputeAction7(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getDataAttributes: Mapping[str, Any]


class DataRoomComputeAction8(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    retrieveModelQualityReport: Mapping[str, Any]


class GetCustomAudiences(BaseModel):
    user: str


class DataRoomComputeAction10(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getCustomAudiences: GetCustomAudiences


class GetSeedAudiences(GetCustomAudiences):
    pass


class DataRoomComputeAction11(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getSeedAudiences: GetSeedAudiences


class Kind68(Enum):
    BASE = 'BASE'


class AudienceReference16(BaseModel):
    kind: Kind68


class Kind69(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference17(BaseModel):
    id: str
    kind: Kind69


class Kind70(Enum):
    SEED = 'SEED'


class AudienceReference18(BaseModel):
    audienceType: str
    kind: Kind70


class AudienceReference(
    RootModel[Union[AudienceReference16, AudienceReference17, AudienceReference18]]
):
    root: Union[AudienceReference16, AudienceReference17, AudienceReference18]


class Kind71(Enum):
    REF = 'REF'


class AudienceReferenceOrDraft1(BaseModel):
    kind: Kind71
    value: AudienceReference


class Kind72(Enum):
    DRAFT = 'DRAFT'


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind73(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition15(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind73
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind74(Enum):
    RULE_BASED = 'RULE_BASED'


class Kind75(Enum):
    REMARKETING = 'REMARKETING'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class SeedAudienceReference(BaseModel):
    audienceType: str


class GetLookalikeAudienceStatistics(BaseModel):
    audienceRef: AudienceReference


class DataRoomComputeAction9(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getLookalikeAudienceStatistics: GetLookalikeAudienceStatistics


class GetAudienceUserList(GetLookalikeAudienceStatistics):
    pass


class DataRoomComputeAction13(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getAudienceUserList: GetAudienceUserList


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class CustomAudienceDefinition17(BaseModel):
    kind: Kind75
    seedAudienceRef: SeedAudienceReference


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition16(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind74
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[
        Union[
            CustomAudienceDefinition15,
            CustomAudienceDefinition16,
            CustomAudienceDefinition17,
        ]
    ]
):
    root: Union[
        CustomAudienceDefinition15,
        CustomAudienceDefinition16,
        CustomAudienceDefinition17,
    ]


class AudienceReferenceOrDraft2(BaseModel):
    kind: Kind72
    value: CustomAudienceDefinition


class AudienceReferenceOrDraft(
    RootModel[Union[AudienceReferenceOrDraft1, AudienceReferenceOrDraft2]]
):
    root: Union[AudienceReferenceOrDraft1, AudienceReferenceOrDraft2]


class EstimateAudienceSize(BaseModel):
    audience: AudienceReferenceOrDraft


class DataRoomComputeAction12(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    estimateAudienceSize: EstimateAudienceSize


class DataRoomComputeAction(
    RootModel[
        Union[
            DataRoomComputeAction1,
            DataRoomComputeAction2,
            DataRoomComputeAction3,
            DataRoomComputeAction4,
            DataRoomComputeAction5,
            DataRoomComputeAction6,
            DataRoomComputeAction7,
            DataRoomComputeAction8,
            DataRoomComputeAction9,
            DataRoomComputeAction10,
            DataRoomComputeAction11,
            DataRoomComputeAction12,
            DataRoomComputeAction13,
        ]
    ]
):
    root: Union[
        DataRoomComputeAction1,
        DataRoomComputeAction2,
        DataRoomComputeAction3,
        DataRoomComputeAction4,
        DataRoomComputeAction5,
        DataRoomComputeAction6,
        DataRoomComputeAction7,
        DataRoomComputeAction8,
        DataRoomComputeAction9,
        DataRoomComputeAction10,
        DataRoomComputeAction11,
        DataRoomComputeAction12,
        DataRoomComputeAction13,
    ] = Field(..., title='DataRoomComputeAction')
